/*
		12a13
		> #define __dv (*(vu16*)0x0892fd19)
		113c114
		< xsprintf(buf, "%02d:%02d", hour, min);
		---
		> xsprintf(buf, "%04X", __dv); 

		Original code by shadowofdarkness
		
		Gba Temp Thread
		https://gbatemp.net/threads/release-gen-1-pokemon-vc-wild-encounter-dv-ntr-overlay.459869/
		
		
		*/

#include "global.h"
#include "ov.h"

FS_archive sdmcArchive = { 0x9, (FS_path){ PATH_EMPTY, 1, (u8*)"" } };
Handle fsUserHandle = 0;

#define CALLBACK_OVERLAY (101)
#define TICKS_PER_MSEC (268123.480)


#define __ver (*(vu16*)0x0880014b) /*Game Version Location variable*/

#define __dvb (*(vu16*)0x0892fd19) /*Pokemon Blue DV locaion*/
#define __dvr (*(vu16*)0x089300a9) /*Pokemon Red DV locaion*/
#define __dvy (*(vu16*)0x08930578) /*Pokemon Yellow DV locaion*/

int frameCount[2];
u64 lastUpdatedTick[2];
int fps[2];


void drawWidget(int calculateFps, int isBottom, u32 addr, u32 stride, u32 format, u32 colOffset) {
	u32 height = isBottom ? 320 : 400;
	char buf[30];
	


if (__ver == 0x4220) /*Pokemon Blue*/
	{
    
	ovDrawTranspartBlackRect(addr, stride, format, 9, colOffset, 12, 80 + 4, 1);
	xsprintf(buf, "%04X", __dvb); 
	ovDrawString(addr, stride, format, height, 11, colOffset + 4, 255, 255, 255, buf);
	}
	
	
	
 
else if (__ver == 0x5220) /*Pokemon Red*/
	{
     
	ovDrawTranspartBlackRect(addr, stride, format, 9, colOffset, 12, 80 + 4, 1);
	xsprintf(buf, "%04X", __dvr); 
	ovDrawString(addr, stride, format, height, 11, colOffset + 4, 255, 255, 255, buf);
	}
	
	
	
 
else if (__ver == 0x5920) /*Pokemon Yellow*/
	{
      
	ovDrawTranspartBlackRect(addr, stride, format, 9, colOffset, 12, 80 + 4, 1);
	xsprintf(buf, "%04X", __dvy); 
	ovDrawString(addr, stride, format, height, 11, colOffset + 4, 255, 255, 255, buf);
	}
	
	
	
 
else
{
	ovDrawTranspartBlackRect(addr, stride, format, 9, colOffset, 12, 80 + 4, 1);
	xsprintf(buf, "FAIL"); 
	ovDrawString(addr, stride, format, height, 11, colOffset + 4, 255, 255, 255, buf); 
}
}	







/*
Overlay Callback.
isBottom: 1 for bottom screen, 0 for top screen.
addr: writable cached framebuffer virtual address, should flush data cache after modifying.
addrB: right-eye framebuffer for top screen, undefined for bottom screen.
stride: framebuffer stride(pitch) in bytes, at least 240*bytes_per_pixel.
format: framebuffer format, see https://www.3dbrew.org/wiki/GPU/External_Registers for details.

return 0 on success. return 1 when nothing in framebuffer was modified.
*/

u32 overlayCallback(u32 isBottom, u32 addr, u32 addrB, u32 stride, u32 format) {
	drawWidget(1, isBottom, addr, stride, format, 14);
	if ((isBottom == 0) && (addrB) && (addrB != addr))  {
		drawWidget(0, isBottom, addrB, stride, format, 10);
	}
	return 0;
}

int main() {
	u32 retv;
	
	initSharedFunc();
	plgRegisterCallback(CALLBACK_OVERLAY, (void*) overlayCallback, 0);
	return 0;
}

